*****************************************************************************
      real*8 function ran1(idum)
*****************************************************************************
      implicit real*8(a-h,p-z)

      dimension r(97)
      parameter(m1=259200,ia1=7141,ic1=54773,rm1=3.8580247d-6)
      parameter(m2=134456,ia2=8121,ic2=28411,rm2=7.4373773d-6)
      parameter(m3=243000,ia3=4561,ic3=51349)
      data iff /0/

      if(idum.lt.0.or.iff.eq.0)then
	 iff=1
	 ix1=mod(ic1-idum,m1)
	 ix1=mod(ia1*ix1+ic1,m1)
	 ix2=mod(ix1,m2)
	 ix1=mod(ia1*ix1+ic1,m1)
	 ix3=mod(ix1,m3)
	 do 11 j=1,97
	    ix1=mod(ia1*ix1+ic1,m1)

	    ix2=mod(ia2*ix2+ic2,m2)
	    r(j)=(dble(ix1)+dble(ix2)*rm2)*rm1
11       continue
         idum=1
      end if
      ix1=mod(ia1*ix1+ic1,m1)
      ix2=mod(ia2*ix2+ic2,m2)
      ix3=mod(ia3*ix3+ic3,m3)
      j=1+(97*ix3)/m3
      if(j.gt.97.or.j.lt.1)write(6,*) ' error in ran1 '
      ran1=r(j)
      r(j)=(dble(ix1)+dble(ix2)*rm2)*rm1
      return
      end
      
****************************************************************************
      subroutine formcf(smin,smax,nsorc,nterms,q,kbsmin,kbsmax,
     >                  source,strength,coeffs,ions,
     >               alogq,qsq,factor,kcut)
****************************************************************************
      implicit real*8(a-h,o-z)
      parameter (jsmax=40000,icfmax=400000,kbmax=400)
      real*8 source(jsmax),strength(jsmax),coeffs(icfmax)
      integer ions(-kbmax:kbmax)

      qsq=q*q
      ntp=nterms+1
      ntpsq=ntp*ntp

c     Creates coefficients for each box between minimum and maximum

c     First compute minimum and maximum box numbers
      
      alogq=dlog(q)
      factor=0.50d0/alogq
cc      write(6,*) ' alogq,smin,smax ',alogq,smin,smax
      kbsmin=ifloor(0.50d0+factor*dlog(smin))
      kbsmax=ifloor(0.50d0+factor*dlog(smax))+1

c     For error checking: comment out when timing
ccc      sbmin=qsq**(kbsmin-1)
ccc      if(sbmin.gt.smin)write(6,*) ' Problem -- sbmin>smin ',sbmin,smin
ccc      sbmax=qsq**(kbsmax+1)
ccc      if(sbmax.lt.smax)write(6,*) ' Problem -- sbmax<smax ',sbmax,smax
ccc      write(6,*) ' kbs min and max = ',kbsmin,kbsmax

c     Set all coefficients to zero

      kbstart=1-ntpsq
      do 5 kbox=kbsmin,kbsmax

      ions(kbox)=0

c     Coeffs for this box start at address 
      kbstart=kbstart+ntpsq
      kbadr=kbstart-1
      do 6 n=0,nterms
      do 7 m=0,nterms
      kbadr=kbadr+1
      coeffs(kbadr)=0.0d0
7     continue
6     continue
5     continue

      do 10 j=1,nsorc

      sj=source(j)
      kbox=ifloor(0.50d0+factor*dlog(sj))
      sb=qsq**kbox

c     For error checking: comment out when timing
ccc      sbmin=sb/q
ccc      sbmax=sb*q
ccc      if(sbmin.gt.sj.or.sbmax.lt.sj)
ccc     >                     write(6,*) ' sj in wrong box ',j,sj,sb
ccc      write(6,*) ' sj,kbox,sb ',sj,kbox,sb

c     Add contribution of this source to coeffs for box kbox

c     Set pointer to 1 since this box is nonempty
      ions(kbox)=1

c     Coeffs for this box start at address 
      kbstart=(kbox-kbsmin)*ntpsq+1

      z1=sb/sj
      z2=0.5d0*(1.0d0+z1)
      z3=1.0d0-z1

      kbadr=kbstart-1
      update=strength(j)*z1
      temp=update
      do 20 n=0,nterms
      update=temp
      do 30 m=0,nterms

c     Address of this coefficient is
ccc      kbadr=kbstart+n*(nterms+1)+m
      kbadr=kbadr+1

ccc      update=strength(j)*z1*z2**n*z3**m
      coeffs(kbadr)=coeffs(kbadr)+update
      update=z3*update
30    continue
      temp=z2*temp
20    continue

10    continue

      return
      end

****************************************************************************
      subroutine assign(q,kctmin,kctmax,tmin,tmax,mtarg,
     >            target,itbox,iont,
     >               alogq,qsq,factor,kcut)
****************************************************************************

      implicit real*8(a-h,o-z)
      parameter (jsmax=40000,kbmax=400)
      real*8 target(jsmax)
      integer iont(-kbmax:kbmax),itbox(jsmax)

      kctmin=ifloor(0.50d0+factor*dlog(tmin))
      kctmax=ifloor(0.50d0+factor*dlog(tmax))+1

      do 10 i=1,mtarg

      ti=target(i)
      kbox=ifloor(0.50d0+factor*dlog(ti))

c     For error checking: comment out when timing
ccc      tc=q**(2*kbox)
ccc      tcmin=tc/q
ccc      tcmax=tc*q
ccc      if(tcmin.gt.ti.or.tcmax.lt.ti)
ccc     >                     write(6,*) ' ti in wrong box ',i,ti,tc

      itbox(i)=kbox
      iont(kbox)=1
ccc      write(6,*) ' i,ti,kbox ',i,ti,kbox

10    continue

      return
      end

****************************************************************************
      subroutine transt(kbsmin,kbsmax,kctmin,kctmax,nterms,q,toler,
     >               coeffs,coefft,ions,iont,
     >               alogq,qsq,factor,kcut)
****************************************************************************

      implicit real*8(a-h,o-z)
      parameter (jsmax=40000,kbmax=400,icfmax=400000)
      real*8 coeffs(icfmax),coefft(icfmax)
      integer ions(-kbmax:kbmax),iont(-kbmax:kbmax)
      real*8 poly(0:200),b(0:200,0:200)

c     Initialize factorials
ccc      fac(0)=1.0d0
ccc      do 100 j=1,2*nterms
ccc      fac(j)=fac(j-1)*dble(j)
ccc100   continue

c     Initialize binomial coefficients
      do 110 n=0,nterms
      m=0
      bin=1.0d0
      b(m,n)=bin
      do 120 m=1,nterms
      bin=dble(n+m)*bin/dble(m)  
      b(m,n)=bin
120   continue
110   continue

      ntp=nterms+1
      ntpsq=ntp*ntp
      nt2=2*nterms-1
ccc      qsq=q*q

c     Cutoff for boxes
ccc      alogq=dlog(q)
ccc      factor=0.50d0/alogq
ccc      kcut=1+ifloor(factor*dlog(dlog(1.0d0/toler)))
      kcut=ifloor(factor*dlog(dlog(1.0d0/toler)))
ccc      write(6,*) ' kcut = ',kcut

ccc      write(6,*) ' kctmin,kctmax = ',kctmin,kctmax
      do 10 kbox=kctmin,kctmax
      if(iont(kbox).eq.1)then

c     Set coefft to zero

c     Coeffs for this box start at address 
      kcstart=(kbox-kctmin)*ntpsq+1

c     Center of the box is tc
      tc=qsq**kbox
ccc      write(6,*) 'kcstart,tc ',kcstart,tc

      kcadr=kcstart-1
      do 20 n=0,nterms
      do 30 m=0,nterms

ccc      kcadr=kcstart+n*(nterms+1)+m
      kcadr=kcadr+1
      coefft(kcadr)=0

30    continue
20    continue

c     Accumulate coeffs into coefft
      
c     Loop over nonempty source boxes within range

      do 40 ksor=kbsmin,min(kcut-kbox,kbsmax)

      if(ions(ksor).eq.1)then

c     Coefficients for source box start at this address
      kbstart=(ksor-kbsmin)*ntpsq+1

c     Center of the source box is sb
      sb=qsq**ksor
ccc      write(6,*) 'ksor,kbstart,sb ',ksor,kbstart,sb

c     Tabulate Laguerre functions of z=tc*sb.

      z=tc*sb
      poly(0)=dexp(-z)
      a1=1.0d0-z
      a2=0.0d0
      poly(1)=a1*poly(0)
      do 60 j=1,nt2
      a1=a1+2.0d0
      a2=a2+1.0d0
      poly(j+1)=(a1*poly(j)-a2*poly(j-1))/dble(j+1)
ccc      poly(j+1)=((dble(2*j+1)-z)*poly(j)-dble(j)*poly(j-1))/dble(j+1)
ccc      write(6,*) ' j,poly(j) ',j,poly(j)
60    continue

c     Transform coefficients and accumulate
     
      kcadr=kcstart-1
      kbadr=kbstart-1
      do 70 n=0,nterms

      m=0
ccc      bin=1.0d0
      kcadr=kcadr+1
      kbadr=kbadr+1
      update=poly(m+n)*coeffs(kbadr)
      coefft(kcadr)=coefft(kcadr)+update
ccc      write(6,*) ' kbadr,kcadr,update ',kbadr,kcadr,update
      do 80 m=1,nterms

ccc      bin=(n+m)*bin/m  
ccc      bin=fac(n+m)/(fac(m)*fac(n))
      bin=b(m,n)
ccc      kcadr=kcstart+n*(nterms+1)+m
ccc      kbadr=kbstart+n*(nterms+1)+m
      kcadr=kcadr+1
      kbadr=kbadr+1

      update=bin*poly(m+n)*coeffs(kbadr)
      coefft(kcadr)=coefft(kcadr)+update
ccc      write(6,*) ' kbadr,kcadr,update ',kbadr,kcadr,update

80    continue
70    continue

      end if

40    continue

      end if

10    continue

      return
      end

****************************************************************************
      subroutine eval(mtarg,nterms,kctmin,kctmax,q,
     >                target,coefft,iont,transform,itbox,
     >               alogq,qsq,factor,kcut)
****************************************************************************

      implicit real*8(a-h,o-z)
      parameter (jsmax=40000,icfmax=400000,kbmax=400)
      real*8 target(jsmax),transform(jsmax),
     >       coefft(icfmax)
      integer iont(-kbmax:kbmax),itbox(jsmax)

c     Evaluate series

      ntp=nterms+1
      ntpsq=ntp*ntp
ccc      qsq=q*q

      do 90 i=1,mtarg

      ti=target(i)
      kbox=itbox(i)
      kcstart=(kbox-kctmin)*ntpsq+1
      tc=qsq**kbox
ccc      write(6,*) ' tc/q,ti,tc*q ',tc/q,ti,tc*q

      z3=tc/ti
      z1=0.50d0*(1.0d0+z3)
      z2=1.0d0-z3
ccc      write(6,*) ' i,ti,z1,z2,z3 ',i,ti,z1,z2,z3


c     Old method
ccc      sum=0.0d0
ccc      kcadr=kcstart-1
ccc      do 100 n=0,nterms
ccc      do 110 m=0,nterms
cccccc      kcadr=kcstart+n*(nterms+1)+m
ccc      kcadr=kcadr+1
ccc      sum=sum+z1**m*z2**n*coefft(kcadr)
ccc110   continue
ccc100   continue
ccc      temp=sum*z3
ccc      transform(i)=sum*z3

c     New method
      sum=0.0d0
      kcadr=kcstart+ntpsq-1
      do 200 n=nterms,1,-1
      cn=0.0d0
      do 210 m=nterms,1,-1
ccc      kcadr1=kcstart+n*(nterms+1)+m
ccc      write(6,*) ' m,n,kcadr,kcadr1 ',m,n,kcadr,kcadr1
      cn=z1*(coefft(kcadr)+cn)
      kcadr=kcadr-1
210   continue
      m=0
ccc      kcadr1=kcstart+n*(nterms+1)+m
ccc      write(6,*) ' m,n,kcadr,kcadr1 ',m,n,kcadr,kcadr1
      cn=coefft(kcadr)+cn
      kcadr=kcadr-1
      sum=z2*(cn+sum)
200   continue
      n=0
      c0=0.0d0
      do 220 m=nterms,1,-1
ccc      kcadr1=kcstart+n*(nterms+1)+m
ccc      write(6,*) ' m,n,kcadr,kcadr1 ',m,n,kcadr,kcadr1
      c0=z1*(coefft(kcadr)+c0)
      kcadr=kcadr-1
220   continue
      m=0
ccc      kcadr1=kcstart+n*(nterms+1)+m
ccc      write(6,*) ' m,n,kcadr,kcadr1 ',m,n,kcadr,kcadr1
      c0=coefft(kcadr)+c0
      sum=c0+sum

ccc      write(15,*) ' i,temp,sum*z3 ',i,temp,sum*z3
      transform(i)=sum*z3

90    continue

      return
      end



****************************************************************************
      subroutine direct(nsorc,imax,source,strength,target,exact)
****************************************************************************
      implicit real*8(a-h,o-z)
      parameter (jsmax=40000,kbmax=400,icfmax=400000)
      real*8 source(jsmax),strength(jsmax),
     >       target(jsmax),exact(100)

      do 120 i=1,imax
      sum=0.0d0
      do 130 j=1,nsorc
      sum=sum+strength(j)*dexp(-target(i)*source(j))
130   continue
      exact(i)=sum
120   continue

      return
      end

****************************************************************************
      integer function ifloor(x)
****************************************************************************
      real*8 x
      ifloor=int(x)
      if(x.lt.0.)ifloor=ifloor-1
ccc      write(6,*) ' x,ifloor ',x,ifloor
      return
      end
